#!/usr/bin/env ruby

require "thread"
require "net/ftp"
require "shellwords"

class AFTP
  # ץץ
  PROMPT = "> "
  # ɤԤåɤκ
  MAX_THREADS = 2

  def initialize(host, user, password)
    # ³ۥ
    @host = host
    # 桼
    @user = user
    # ѥ
    @password = password
    # FTP³
    @ftp = Net::FTP.new(host, user, password)
    # ޥɤб᥽åɤHash˳Ǽ
    @commands = {
      "pwd" => method(:pwd),
      "cd" => method(:cd),
      "ls" => method(:ls),
      "dir" => method(:ls),
      "get" => method(:get),
      "abort" => method(:abort),
      "status" => method(:status),
      "quit" => method(:quit)
    }
    # ɽΥֹ
    @seqno = 0
    # DownloaderǼ
    @downloaders = []
    # ɤԤåɤο
    @num_threads = 0
    # num_threadsݸMutex
    @num_threads_mutex = Mutex.new
    # åɿMAX_THREADS꾮ʤΤԤľѿ
    @thread_available_cond = ConditionVariable.new
  end

  def run
    while line = readline(PROMPT)
      # Ϥñʬ
      args = Shellwords.shellwords(line)
      # ǽñ򥳥ޥ̾Ȥߤʤ
      cmd = args.shift
      # Τʤޥɤλϥ顼
      unless @commands.has_key?(cmd)
	$stderr.printf("unknown command: %s\n", cmd)
	next
      end
      begin
        # ޥɤб᥽åɤθƤӽФ
	@commands[cmd].call(*args)
      rescue
	$stderr.puts($!)
      end
    end
  end

  # ץץȤϤϤɤ߹
  def readline(prompt)
    print prompt
    return gets
  end

  # ȥǥ쥯ȥɽ
  def pwd
    puts @ftp.pwd
  end

  # ȥǥ쥯ȥѹ
  def cd(dir)
    @ftp.chdir(dir)
    puts dir
  end

  # եΥꥹȤɽ
  def ls(*args)
    @ftp.list(*args) do |line|
      puts line
    end
  end

  # Ʊ˥եɤ
  def get(remote, local = File.basename(remote))
    Thread.start do
      dir = @ftp.pwd
      # Downloader֥Ȥ
      downloader = Downloader.new(@host, @user, @password,
				  dir, remote, local, @seqno)
      @downloaders.push(downloader)
      @seqno += 1
      begin
	@num_threads_mutex.synchronize do
          # ߤΥåɿ祹åɿƱ硢
          # åɿΤԤġ
	  while @num_threads == MAX_THREADS
	    @thread_available_cond.wait(@num_threads_mutex)
	  end
          # åɿΥ󥯥
	  @num_threads += 1
	end
	begin
	  downloader.run
	ensure
	  @num_threads_mutex.synchronize do
            # åɿΥǥ
	    @num_threads -= 1
            # åɤѲǽˤʤäȤ
	    @thread_available_cond.signal
	  end
	  @downloaders.delete(downloader)
	end
      rescue Abort
	printf("%d: aborted\n", downloader.seqno)
	print PROMPT
      rescue
	$stderr.puts($!)
	print PROMPT
      end
    end
  end

  # ɤǤ
  def abort(seqno)
    seqno = seqno.to_i
    # seqnoбDownloader֥Ȥõ
    target = @downloaders.find { |d| d.seqno == seqno }
    # бDownloader֥Ȥ¸ߤʤ硢顼
    unless target
      $stderr.printf("no such thread: %d\n", seqno)
      return
    end
    # Downloader֥Ȥб륹åɤ㳰ꤲ
    target.thread.raise(Abort.new)
  end

  # ɽξ֤ɽ
  def status
    for downloader in @downloaders
      puts downloader.info
    end
  end

  # λԤ
  def quit
    # ٤ƤΥɽ
    for downloader in @downloaders
      downloader.thread.raise(Abort.new)
      downloader.thread.join
    end
    @ftp.quit
    @ftp.close
    exit
  end

  # ɤԤ饹
  class Downloader
    attr_reader :seqno, :running, :thread

    def initialize(host, user, password,
		   dir, remote, local, seqno)
      # ѤFTP³򥪡ץ
      @ftp = Net::FTP.new(host, user, password)
      # ȥǥ쥯ȥѹ
      @ftp.chdir(dir)
      # ɸΥѥ
      @remote = remote
      # Υѥ
      @local = local
      # ֹ
      @seqno = seqno
      # ɤ߹Хȿ
      @read_bytes = 0
      # ¹椫ɤɽե饰
      @running = false
      # б륹å
      @thread = Thread.current
    end

    # ɽ
    def run
      @running = true
      printf("%d: started\n", @seqno)
      print PROMPT
      begin
        # եɤ
	@ftp.getbinaryfile(@remote, @local, 4096) do |data|
	  @read_bytes += data.size
	end
	printf("%d: completed\n", @seqno)
	print PROMPT
      rescue Abort
        # ߤ줿
	@ftp.abort
	raise
      ensure
        # ɬλԤ
	@ftp.quit
	@ftp.close
      end
    end

    # ֤֤
    def info
      if @running
	return format("%d:%s: running -- %d bytes read",
		      @seqno, File.basename(@remote), @read_bytes)
      else
	return format("%d:%s: waiting",
		      @seqno, File.basename(@remote))
      end
    end
  end

  class Abort < Exception
  end
end

$stdout.sync = true

host = ARGV.shift
unless host
  print "host: "
  host = gets.chomp
end
print "user: "
user = gets.chomp
print "password: "
# Ϥ򥨥Хåʤ褦sttyޥɤǻ
system("stty", "-echo")
begin
  password = gets.chomp
ensure
  system("stty", "echo")
end
print "\n"

begin
  aftp = AFTP.new(host, user, password)
  aftp.run
rescue
  $stderr.puts($!)
  exit 1
end
